<template>
  <div>
    <v-data-table
      :headers="headers"
      :items="dataExpenses"
      :items-per-page="40"
      :sort-by.sync="sortBy"
      :sort-desc.sync="sortDesc"
      item-key="id"
      multi-sort
      class="elevation-1"
    >
      <template #item.unitExpenses="{ item }">
        <span>{{ item.unitExpenses.name }}</span>
      </template>
      <template #item.price="{ item }">
        <v-chip :color="getColor(item.typeExpenses.id)" dark>
          <moneyFormat :getPrice="item.price" />
        </v-chip>
      </template>

      <template #item.listExpenses="{ item }">
        <span>{{ item.listExpenses.name }}</span>
      </template>
      <template #item.date="{ item }">
        <dateFormat :getDate="item.date" />
        <!-- <dateFormat :getDate="item.date"> -->
      </template>
      <template #item.storesExpenses="{ item }">
        <span>{{ item.storesExpenses.name }}</span>
      </template>
      <template #item.action="{ item }">
        <!-- <v-tooltip bottom>
          <template v-slot:activator="{ on, attrs }">
            <v-btn
              class="mr-1 mb-2"
              color="blue darken-2"
              v-bind="attrs"
              v-on="on"
              small
              dark
            >
              <v-icon icon small dark> mdi-map-marker </v-icon>
            </v-btn>
          </template>
          <span>พิกัด</span>
        </v-tooltip> -->
        <v-tooltip v-if="item.doc != '-'" bottom>
          <template v-slot:activator="{ on, attrs }">
            <v-btn
              class="mr-1 mb-2"
              color="green darken-2"
              v-bind="attrs"
              v-on="on"
              small
              dark
              :href="item.doc"
              target="_blank"
            >
              <v-icon icon small dark> mdi-image-multiple-outline </v-icon>
            </v-btn>
          </template>
          <span>เอกสาร</span>
        </v-tooltip>
      </template>
    </v-data-table>
  </div>
</template>
<script>
import axios from 'axios'
import { mapGetters, mapActions, mapState } from 'vuex'
import dateFormat from '@/components/functional/dateFormat'
import moneyFormat from '@/components/functional/moneyFormat'
export default {
  components: {
    dateFormat,
    moneyFormat,
  },
  props: {
    setDataDate: Number,
  },
  data() {
    return {
      sortBy: ['date', 'no', 'listExpenses'],
      sortDesc: true,
      dataExpenses: [],
      headers: [
        {
          text: 'เลขใบเสร็จ',
          value: 'no',
          align: 'center',
          class: 'subtitle-2 font-weight-bold',
        },
        {
          text: 'ประเภทค่าใช้จ่าย',
          value: 'listExpenses',
          align: 'center',
          sort: function (a, b) {
            var nameA = a.name.toUpperCase()
            var nameB = b.name.toUpperCase()
            if (nameA < nameB) {
              return -1
            }
            if (nameA > nameB) {
              return 1
            }
            // names must be equal
            return 0
          },
          class: 'subtitle-2 font-weight-bold',
        },
        {
          text: 'จำนวน',
          align: 'center',
          value: 'amount',
          class: 'subtitle-2 font-weight-bold',
        },
        {
          text: 'หน่วย',
          value: 'unitExpenses',
          sort: function (a, b) {
            var nameA = a.name.toUpperCase()
            var nameB = b.name.toUpperCase()
            if (nameA < nameB) {
              return -1
            }
            if (nameA > nameB) {
              return 1
            }
            // names must be equal
            return 0
          },
          class: 'subtitle-2 font-weight-bold',
        },
        {
          text: 'ราคา',
          value: 'price',
          align: 'center',
          class: 'subtitle-2 font-weight-bold',
        },
        {
          text: 'วันที่ซื้อสินค้า',
          value: 'date',
          align: 'center',
          class: 'subtitle-2 font-weight-bold',
        },
        {
          text: 'ร้านค้า',
          value: 'storesExpenses',
          sort: function (a, b) {
            var nameA = a.name.toUpperCase()
            var nameB = b.name.toUpperCase()
            if (nameA < nameB) {
              return -1
            }
            if (nameA > nameB) {
              return 1
            }
            // names must be equal
            return 0
          },
          class: 'subtitle-2 font-weight-bold',
        },
        {
          text: 'รายละเอียด',
          value: 'detail',
          align: 'center',
          sortable: false,
          class: 'subtitle-2 font-weight-bold',
        },
        {
          text: 'เครื่องมือ',
          align: 'center',
          value: 'action',
          sortable: false,
          class: 'subtitle-2 font-weight-bold ',
        },
      ],
    }
  },
  mounted() {},
  watch: {
    getdashboardTime() {
      this.dataExpenses = this.$nuxt.$store.state.expensestable.ExpensesTable
    },
    async setDataDate(newVal, oldval) {
      // const dataDaily = await axios
      //   .get('api/expenses/todaylist/' + newVal)
      //   .then((response) => {
      //     return response.data
      //   })
      // this.dataExpenses = dataDaily
      let firstDate = parseInt(newVal)
      let lastDate = parseInt(newVal) + 86390000
      const dateFind = this.$nuxt.$store.state.expensestable.ExpensesTable.filter(
        (dataval) => {
          return (
            new Date(dataval.date).getTime() >= firstDate &&
            new Date(dataval.date).getTime() <= lastDate
          )
        }
      )
      this.dataExpenses = dateFind
    },
  },
  computed: {
    ...mapState({
      getdashboardTime: (state) => state.template.dashboardTime,
    }),
  },
  methods: {
    getColor(valID) {
      if (valID == 1) return '#3CD4A0'
      if (valID == 2) return '#8c98a1'
      if (valID == 3) return 'rgb(255, 92, 147)'
      if (valID == 4) return 'rgb(255, 194, 96)'
      if (valID == 5) return 'rgb(83, 109, 254)'
      if (valID == 6) return '#8a18e7'
    },
  },
}
</script>
